package edu.wpi.cs.jsh;

import edu.wpi.cs.jsh.NamedStream;

/**
 * Abstract base class that takes care of all of the simple named stream code.
 */
abstract class AbstractBaseStream implements NamedStream {

    protected final String m_name;
    protected final Class<?> m_type;

    protected AbstractBaseStream(String name, Class<?> type) {
        m_name = name;
        m_type = type;
    }

    @Override
    public String getName() {
        return m_name;
    }

    @Override
    public Class<?> getStreamClass() {
        return m_type;
    }
}
