package edu.wpi.cs.jsh;

import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.Collection;
import java.util.LinkedList;
import java.util.Map;

/**
 * Serializes a {@link BasicStream} according to the JshProtocol
 */
class BasicStreamSerializer implements JsonSerializer<BasicStream> {
    @Override
    public JsonElement serialize(BasicStream basicStream, Type type, JsonSerializationContext jsonSerializationContext) {
        JsonArray output = new JsonArray();
        output.add(jsonSerializationContext.serialize(basicStream.getSubStreams()));
        return output;
    }
}
