package edu.wpi.cs.jsh;

import java.lang.reflect.Type;

/**
 * A named stream is a JshStream that has the concept of having a name and some value. NamedStream implementations should
 * actually implement one of {@link Stream} or {@link TypeStream}
 */
public interface NamedStream {

    /**
     * Gets the name associated with this named stream
     *
     * @return The stream name
     */
    String getName();

    /**
     * Gets the class associated with this named stream for equality checking
     *
     * @return The class of the value of this stream
     */
    Class<?> getStreamClass();

}
