package edu.wpi.cs.jsh;

import com.google.gson.JsonElement;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;

import java.lang.reflect.Type;

/**
 * Serializer for the top level stream, which is the same as the rest of the streams except that it does not wrap the stream
 * in an array object.
 */
public class TopLevelStreamSerializer implements JsonSerializer<BasicStream> {
    @Override
    public JsonElement serialize(BasicStream basicStream, Type type, JsonSerializationContext jsonSerializationContext) {
        return jsonSerializationContext.serialize(basicStream.getSubStreams());
    }
}
